/*
 * PM - 2018
 * Proiect
 * Danaila Larisa-Andreea
 */

#include <avr/io.h>
#include <util/delay.h>
#define F_CPU 16000000UL //Defines clock speed
#define USART_BAUDRATE 9600 //Baudrate for serial comm.
#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)

char state;
char rot_dir = 'L';
int speed1 = 800;
int speed2 = 800;


char get_data(void) {

	while (!(UCSR0A & (1 << RXC0)));
	return UDR0; // retrieves byte from serial port (bluetooth module)


}

void forward(void)
{
    state = 'U';
	PORTB = 0;
    //PORTB |= (1<<PB0) | (1<<PB6);
	PORTB |= (1<<PB7) | (1 << PB6);

	//PORTB &= ~(1<<PB2) & ~(1<<PB4);
    OCR1A = speed1;
    OCR1B = speed2;
}

void backward(void)
{
    state = 'D';
	PORTB = 0;
//	PORTB &= ~(1<<PB0) & ~(1<<PB3);
    PORTB |= (1<<PB2) | (1<<PB5);
    OCR1A = speed1;
    OCR1B = speed2;
}
void stop(void)
{


    PORTB = 0;
    OCR1A = 0;
    OCR1B = 0;

}

void right_turn(void)
{

	OCR1A = speed1;
    OCR1B = speed2;
	if (state == 'D') {
		PORTB = 0;
		PORTB |= (1<<PB7);

	} else {
		PORTB = 0;
		PORTB |= (1<<PB6);

	}
}

void left_turn(void)
{
	OCR1A = speed1;
	OCR1B = speed2;
	if (state == 'D') {
		PORTB = 0;
		PORTB |= (1<<PB6);
	} else {
		PORTB = 0;
		PORTB |= (1<<PB7);

	}
}

void left_pirouette(void)
{
    state = 'a';
    rot_dir = 'L';

	PORTB = 0;
	PORTB |= (1<<PB7);

    OCR1A = speed1;
    OCR1B = speed2;
}

void right_pirouette(void)
{
    state = 'e';
    rot_dir = 'R';

	PORTB = 0;
	PORTB |= (1<<PB6);
    OCR1A = speed1;
    OCR1B = speed2;
}

void faster(void)
{

    if (speed1 < 1000 && speed2 < 1000)
    {
        speed1 += 10;
		speed2 += 10;

    }
	if (state == 'U') forward();
	else if (state == 'D') backward();
}

void slower(void)
{

    if (speed1 > 600 && speed2 > 600)
    {
        speed1 -= 10;
		speed2 -= 10;

    }
	if (state == 'U') forward();
	else if (state == 'D') backward();
}
void check_ultrasonic(void) //still working on this
{
	// doesn't working
}

void motoare(void)
{
	DDRB |= (1 << PB7) | (1 << PB5) | (1 << PB2) | (1 << PB6);

	while(1) {

		char received_byte;
	    received_byte = get_data();

	    switch (received_byte) // which ASCII character was received?
	    {

	        case 'U':   forward();
	                    break; // increase PWM duty cycle

	        case 'C':   stop();
	                    break; // break motor by raising both direction inputs, PWM duty cycle 0%

	        case 'D':   backward();
						DDRD |= (1 << PD7);
						PORTD ^= (1 << PD7);

	                    break; // decrease PWM duty cycle

	        case 'L':   left_turn();
	                    break;

	        case 'R':   right_turn();
	                    break;

	        case 'a':   left_pirouette();
	                    break;

	        case 'e':   right_pirouette();
	                    break;

	        case 'f':   faster();
	                    break;

	        case 's':   slower();
	                    break;

	        default:
	                    break; // character unknown to my routine, discard character

	    }
		// check_ultrasonic();
	}

}

void test(void) {
	DDRB |= (1 << PB0) | (1 << PB5) | (1 << PB2) | (1 << PB6);
	forward();
	_delay_ms(5000);
	backward();

}
/*
void init_timer0(void)
{
	TCCR0A |= (1 << WGM00) | (1 << WGM01) | (1 << COM0A1) | (1 << COM0B1);
	TCCR0B |= (1 << CS00);
	OCR0A = 0;
	OCR0B = 0;

}*/


void pwm_init(void)
{
	// fast pwm cu top la ICR1 si prescaler de 256
	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);

	ICR1 = 1024; // 0x3ff
	// OC1A este la pd5 si OC1B  este la pd4
	OCR1A = 0; // OCR1A = x * TOP / 100; x = factor de umplere
	OCR1B = 0;
}

void init_usart(void)
{

	//UART
	UCSR0A = 0;
    UCSR0B |= (1 << RXEN0) | (1 << TXEN0); //enable Tx and Rx
    UCSR0C |= (1 << UCSZ00) | (1 << UCSZ01); //8 data bit

    UBRR0L = BAUD_PRESCALE;          //sets
    UBRR0H = (BAUD_PRESCALE >> 8); //baudrate registers

}

int main(void) {

	//init_timer0();
	pwm_init();

	DDRD |= (1 << PD4) | (1 << PD5);
	PORTD |= (1 << PD4) | (1 << PD5);

	init_usart();
	motoare();
	while (1);

	return 0;
}
